local Grid2StatusAuraGroupOptions = {}
Grid2Options.plugins["Grid2StatusAuraGroupOptions"] = Grid2StatusAuraGroupOptions

local L = LibStub("AceLocale-3.0"):GetLocale("Grid2Options")
local DBL = LibStub:GetLibrary("LibDBLayers-1.0")


--{{{  Default Setup

-- {{displaySpellId, <false = any>|<true = mine>|<blinkThreshold>, r, g, b[, r, g, b]...}, spellId1, spellId2, ...}
function Grid2StatusAuraGroupOptions.UpgradeDefaults(dblData)
	local versionsSrc = dblData.versionsSrc
	local class = dblData.classKey

	if (versionsSrc.Grid2StatusAuraGroupOptions < 1) then
		if (Grid2Options.healers[class]) then
			DBL:SetupLayerObject(dblData, "indicators", class, "side-left", {type = "square", level = 9, location = "side-left", size = 5,})

			DBL:SetupLayerObject(dblData, "statuses", class, "group-hots", {type = "auraGroupBuff", spellName = 139, color1 = {r=.9,g=.3,b=.8,a=1}, auraNames = {139, 740, 774, 8936, 33763, 48438}})

			DBL:SetupMapObject(dblData, "statusMap", class, "side-left", "group-hots", 89)

			DBL:SetupLayerObject(dblData, "statuses", class, "healing-prevented", {type = "auraGroupDebuff", spellName = 55593, color1 = {r=.9,g=0,b=.8,a=.75}, auraNames = {41292, 30843, 55593, 45996}})
			DBL:SetupLayerObject(dblData, "statuses", class, "healing-reduced", {type = "auraGroupDebuff", spellName = 12294, color1 = {r=.9,g=0,b=.4,a=1}, auraNames = {19434, 56112, 48301, 12294, 13218, 43461, 13222, 13223, 13224, 27189, 57974, 57975, 32858, 38377, 40599, 34073, 13583, 23169, 45347, 63038, 36023, 36054, 34625, 34366, 32378, 19716, 52645, 36917, 22859, 54378, 28776, 60626, 30423, 59525, 45885, 54525, 35189, 32315, 28440, 44534}})

			DBL:SetupMapObject(dblData, "statusMap", class, "alpha", "healing-prevented", 89)
			DBL:SetupMapObject(dblData, "statusMap", class, "border", "healing-reduced", 89)

			DBL:SetupLayerObject(dblData, "indicators", class, "corner-bottom-right", {type = "square", level = 3, location = "corner-bottom-right", size = 5,})
			DBL:SetupMapObject(dblData, "statusMap", class, "corner-bottom-right", "healing-reduced", 89)
		end
		versionsSrc.Grid2StatusAuraGroupOptions = 1
	end

	if (class == "druid" and versionsSrc.druid.Grid2StatusAuraGroupOptions < 1) then
		DBL:SetupLayerObject(dblData, "statuses", class, "group-GiftOfTheWild", {type = "auraGroupBuff", spellName = 26991, missing = true, color1 = {r=1,g=1,b=0,a=1}, auraNames = {26991, 26990}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-Swiftmend", {type = "auraGroupBuff", spellName = 18562, color1 = {r=.2,g=.6,b=1,a=1}, auraNames = {774, 8936}})

		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-GiftOfTheWild", 69)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-left", "group-Swiftmend", 99)

		versionsSrc.druid.Grid2StatusAuraGroupOptions = 1
	elseif (class == "mage" and versionsSrc.mage.Grid2StatusAuraGroupOptions < 1) then
		DBL:SetupLayerObject(dblData, "statuses", class, "group-DalaranBrilliance", {type = "auraGroupBuff", spellName = 61316, missing = true, color1 = {r=0,g=0,b=1,a=1}, auraNames = {61316, 27126, 27127, 61024}})

		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-DalaranBrilliance", 69)
		versionsSrc.mage.Grid2StatusAuraGroupOptions = 1
	elseif (class == "paladin" and versionsSrc.paladin.Grid2StatusAuraGroupOptions < 1) then
		DBL:SetupLayerObject(dblData, "statuses", class, "group-BlessingOfKings", {type = "auraGroupBuff", spellName = 25898, missing = true, color1 = {r=.8,g=.8,b=1,a=1}, auraNames = {20217, 25898}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-BlessingOfMight", {type = "auraGroupBuff", spellName = 27141, missing = true, color1 = {r=0,g=.8,b=1,a=1}, auraNames = {27140, 27141}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-BlessingOfSanctuary", {type = "auraGroupBuff", spellName = 25899, missing = true, color1 = {r=.8,g=1,b=0,a=1}, auraNames = {20911, 25899}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-BlessingOfWisdom", {type = "auraGroupBuff", spellName = 27143, missing = true, color1 = {r=1,g=0,b=.8,a=1}, auraNames = {27142, 27143}})

		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-BlessingOfKings", 69)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-BlessingOfMight", 59)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-BlessingOfSanctuary", 49)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-BlessingOfWisdom", 39)
		versionsSrc.paladin.Grid2StatusAuraGroupOptions = 1
	elseif (class == "priest" and versionsSrc.priest.Grid2StatusAuraGroupOptions < 1) then
		DBL:SetupLayerObject(dblData, "statuses", class, "group-ShadowProtection", {type = "auraGroupBuff", spellName = 39374, missing = true, color1 = {r=1,g=0,b=.8,a=1}, auraNames = {25433, 39374}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-DivineSpirit", {type = "auraGroupBuff", spellName = 32999, missing = true, color1 = {r=.2,g=.6,b=1,a=1}, auraNames = {27841, 32999}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-PrayerOfFortitude", {type = "auraGroupBuff", spellName = 25392, missing = true, color1 = {r=1,g=.6,b=1,a=1}, auraNames = {25389, 25392}})

		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-ShadowProtection", 69)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-DivineSpirit", 59)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-PrayerOfFortitude", 49)
		versionsSrc.priest.Grid2StatusAuraGroupOptions = 1
	elseif (class == "warrior" and versionsSrc.warrior.Grid2StatusAuraGroupOptions < 1) then
		DBL:SetupLayerObject(dblData, "statuses", class, "group-BattleShout", {type = "auraGroupBuff", spellName = 2048, missing = true, color1 = {r=1,g=0,b=.8,a=1}, auraNames = {2048, 19740, 25782, 469}})
		DBL:SetupLayerObject(dblData, "statuses", class, "group-CommandingShout", {type = "auraGroupBuff", spellName = 2048, missing = true, color1 = {r=1,g=0,b=.8,a=1}, auraNames = {2048, 19740, 25782, 469}})

		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-BattleShout", 69)
		DBL:SetupMapObject(dblData, "statusMap", class, "side-bottom", "group-CommandingShout", 68)
		versionsSrc.warrior.Grid2StatusAuraGroupOptions = 1
	end
	versionsSrc[class].Grid2StatusAuraGroupOptions = 1
end

--}}}


local function getAuraGroupKey(name, mine)
	name = Grid2Options:GetValidatedName(name)
	if (name and name ~= "") then
		return "group-" .. name .. (mine and "-mine" or "")
	else
		return nil
	end
end

local newStatusAuraGroupName = ""
local function getNewStatusAuraGroupNameValue()
	return newStatusAuraGroupName
end
local function setNewStatusAuraGroupNameValue(info, auraGroupName)
	newStatusAuraGroupName = auraGroupName
end


local newStatusBuffMine = true
local function getNewStatusBuffMine()
	return newStatusBuffMine
end
local function setNewStatusBuffMine(info, mine)
	newStatusBuffMine = mine
end


local newBuffLayerIndex = 1
local function getNewBuffLayer(info)
	return newBuffLayerIndex
end

local function setNewBuffLayer(info, index)
	newBuffLayerIndex = index
end


local function NewStatusAuraGroup()
	local baseKey = getAuraGroupKey(newStatusAuraGroupName, newStatusBuffMine)
	if (baseKey) then
		--Add to options and runtime db
		local dblData = Grid2.dblData
		local dbx = {type = "auraGroupBuff", spellName = newStatusAuraGroupName, mine = newStatusBuffMine, missing = true, color1 = {r=1,g=1,b=0,a=1}, auraNames = {}}
		dbx.auraNames[1] = newStatusAuraGroupName
		local layer = Grid2Options.statusLayers[newBuffLayerIndex]

		DBL:SetupLayerObject(dblData, "statuses", layer, baseKey, dbx)
		DBL:FlattenSetupType(dblData, "statuses")

		--Create the status
		dbx = DBL:GetRuntimeDbx(dblData, "statuses", baseKey)
		local status = Grid2.setupFunc[dbx.type](baseKey, dbx)

		--Create the status options
		local funcMakeOptions = Grid2Options.typeMakeOptions[dbx.type]
		local optionParams = Grid2Options.optionParams[dbx.type]
		local options, subType = funcMakeOptions(self, status, options, optionParams)--, nil, baseKey, statuses)
		if (subType) then
			Grid2Options:AddElementSubType("status", subType, status, options)
		elseif (options) then
			Grid2Options:AddElement("status", status, options)
		end
	end
end

local function NewStatusAuraGroupDisabled()
	local statusKey = getAuraGroupKey(newStatusAuraGroupName, newStatusBuffMine)
	if (statusKey) then
		local statuses = DBL:GetRuntimeSetup(Grid2.dblData, "statuses")
		if (not statuses[statusKey]) then
			return false
		end
	end
	return true
end

function ResetAuraGroupStatuses()
	local setup = Grid2.db.profile.setup
	--Grid2:SetupDefaultStatus(setup)
	Grid2Frame:UpdateAllFrames()
	Grid2Options:AddSetupStatusesOptions(setup, true)
end

local function MakeStatusAuraGroupCreateOptions(reset)
	local options = options or {}

	options.newStatusAuraGroupName = {
		type = "input",
		order = 1,
		width = "full",
		name = L["Name"],
		usage = L["<CharacterOnlyString>"],
		get = getNewStatusAuraGroupNameValue,
		set = setNewStatusAuraGroupNameValue,
	}
	options.newStatusAuraGroupMine = {
		type = "toggle",
		order = 2,
		name = L["Show if mine"],
		desc = L["Display status only if the buff was cast by you."],
		tristate = true,
		get = getNewStatusBuffMine,
		set = setNewStatusBuffMine,
	}
	options.newBuffLayer = {
		type = 'select',
		order = 5,
		name = L["Layer"],
		desc = L["Layer level.  Higher layers (like Class or Spec) supercede lower ones like Account."],
		values = Grid2Options.GetStatusLayerValues,
		get = getNewBuffLayer,
		set = setNewBuffLayer,
	}
	options.newStatusAuraGroup = {
		type = "execute",
		order = 9,
		name = L["New Status"],
		desc = L["Create a new status."],
		func = NewStatusAuraGroup,
		disabled = NewStatusAuraGroupDisabled,
	}
	options.resetAuraGroupStatuses = {
		type = "execute",
		order = 11,
		name = L["Reset Statuses"],
		desc = L["Reset statuses to defaults."],
		func = ResetAuraGroupStatuses,
	}

	return options
end

--Package a standard set of options for buffs
function Grid2Options:MakeStatusAuraGroupBuffOptions(status, options, optionParams)
	options = options or {}

	optionParams = optionParams or {}
	optionParams.group = "group"
	options = Grid2Options:MakeStatusStandardBuffOptions(status, options, optionParams)

	--Add as a subtype.
	return options, "group"
end

--Package a standard set of options for buffs
function Grid2Options:MakeStatusAuraGroupDebuffOptions(status, options, optionParams)
	options = options or {}

	optionParams = optionParams or {}
	optionParams.group = "group"
	options = Grid2Options:MakeStatusStandardDebuffOptions(status, options, optionParams)

	--Add as a subtype.
	return options, "group"
end


local prev_MakeStatusOptions = Grid2Options.MakeStatusOptions
function Grid2Options:MakeStatusOptions(dblData, reset, ...)
	Grid2Options:AddElementSubTypeGroup("status", "group", MakeStatusAuraGroupCreateOptions(), reset)

	self:AddOptionHandler("auraGroupBuff", Grid2Options.MakeStatusAuraGroupBuffOptions)
	self:AddOptionHandler("auraGroupDebuff", Grid2Options.MakeStatusAuraGroupDebuffOptions)

	prev_MakeStatusOptions(self, dblData, reset, ...)
end
